#include "sprite.h"

Sprite::Sprite(const std::string& file, SDL_Renderer* renderer) {
  tex = loadTexture(file, renderer);
  ren = renderer;

  rect.x = 0;
  rect.y = 0;
  SDL_QueryTexture(tex, NULL, NULL, &rect.w, &rect.h);
}

Sprite::~Sprite() {
  SDL_DestroyTexture(tex);
}

void Sprite::draw() {
  renderTexture(tex, ren, rect);
}

void Sprite::resize(int newW, int newH) {
  rect.w = newW;
  rect.h = newH;
}

void Sprite::move(int newX, int newY) {
  rect.x = newX;
  rect.y = newY;
}
