#include <SDL2/SDL.h>
#include <iostream>
#include <cmath>
#include <memory>

#include "sprite.h"
 
SDL_Window*   window;
SDL_Renderer* renderer;

std::unique_ptr<Sprite> bob1;
std::unique_ptr<Sprite> bob2;
std::unique_ptr<Sprite> bob3;

int newI;

void initialise() {
    SDL_Init( SDL_INIT_EVERYTHING );
    window  = SDL_CreateWindow("SDL Window", 0, 0, 640, 480, 0);
    renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
    SDL_RenderSetLogicalSize( renderer, 640, 480 );
}

void loadSprites() {
    // Load sprite
    bob1 = std::make_unique<Sprite> ("bob.bmp", renderer);
    bob2 = std::make_unique<Sprite> ("bob.bmp", renderer);
    bob3 = std::make_unique<Sprite> ("bob.bmp", renderer);
}

void update() {
   int x, y, w, h;
   int xc = 320;
   int yc = 240;
   
   float angle = newI * 1.0/100;

   w = 100;
   h = 200;

   bob1->move(xc,yc);
   bob2->move(xc + cos(angle)*100, yc + sin(angle)*100);
   bob3->move(xc + cos(angle + M_PI)*100, yc + sin(angle + M_PI)*100);

   bob1->resize(w,h);
   bob2->resize(w,h);
   bob3->resize(w,h);
}

void draw() {
      // Clean scren
      SDL_SetRenderDrawColor( renderer, 0, 0, 0, 255 );
      SDL_RenderClear( renderer );

      bob1->draw();
      bob2->draw();
      bob3->draw();
    
      // Display
      SDL_RenderPresent( renderer);
}


int main() {
  initialise();
  loadSprites();

  std::cout << "[Debug] Loaded." << std::endl;

  for(int i = 0; i < 1000; ++i) {
    newI = i;
    update();
    draw();
  }
}
