#include <SDL2/SDL.h>
#include <iostream>
#include <cmath>
#include <memory>
#include <vector>

#include "sprite.h"
 
SDL_Window*   window;
SDL_Renderer* renderer;

// All sprites
std::vector<std::unique_ptr<Sprite>> sprites;

int sprite_background;
int sprite_bob;

int newI;

void initialise() {
    SDL_Init( SDL_INIT_EVERYTHING );
    window  = SDL_CreateWindow("SDL Window", 0, 0, 640, 480, 0);
    renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
    SDL_RenderSetLogicalSize( renderer, 640, 480 );
}

void loadSprites() {
    // Load sprite
    sprites.push_back( std::make_unique<Sprite> ("background.bmp", renderer) );
    sprite_background = 0;

    sprites.push_back( std::make_unique<Sprite> ("bob.bmp", renderer) );
    sprite_bob = 1;
}

void update() {
   int i = 0;
   for (sprite : sprites) {
     if (i == sprite_background) {
       sprite->resize(640,480);
       sprite->move(0,0);
     }
     else if (i == sprite_bob) {
       sprite->resize(100, 60);
       sprite->move(cos(newI*1.0/100)*200 + 220, 210);
     }
     ++i;
   }
}

void draw() {
      // Clean scren
      SDL_SetRenderDrawColor( renderer, 0, 0, 0, 255 );
      SDL_RenderClear( renderer );
 
      for (sprite : sprites) {
        sprite->draw();
      }

    
      // Display
      SDL_RenderPresent( renderer);
}


int main() {
  initialise();
  loadSprites();

  std::cout << "[Debug] Loaded." << std::endl;

  for(int i = 0; i < 10000; ++i) {
    newI = i;
    update();
    draw();
  }
}
